unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ddsd, StdCtrls, abfComponents, Menus, mmsystem, Registry;

const
  DSSPEAKER_DIRECTOUT   =      0;
  DSSPEAKER_HEADPHONE   =      1;
  DSSPEAKER_MONO        =      2;
  DSSPEAKER_QUAD        =      3;
  DSSPEAKER_STEREO      =      4;
  DSSPEAKER_SURROUND    =      5;
  DSSPEAKER_5POINT1     =      6;
  DSSPEAKER_7POINT1     =      7;

type
  TmainForm = class(TForm)
    DDSD1: TDDSD;
    lbSpk: TListBox;
    Label1: TLabel;
    edNow: TEdit;
    GroupBox1: TGroupBox;
    Label2: TLabel;
    MainMenu1: TMainMenu;
    mnAbout: TMenuItem;
    mnReload: TMenuItem;
    mnExit: TMenuItem;
    cmbDevice: TComboBox;
    GroupBox2: TGroupBox;
    procedure FormCreate(Sender: TObject);
    procedure lbSpkDblClick(Sender: TObject);
    procedure mnAboutClick(Sender: TObject);
    procedure mnExitClick(Sender: TObject);
    procedure mnReloadClick(Sender: TObject);
    procedure cmbDeviceSelect(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
    function SPK_Config( n: DWORD ):Byte;

    procedure SetSPKConfig();
    procedure GetSPKConfig();

    procedure LoadDeviceList();
    procedure SetPlayDevice( devName: string );
    function GetPlayDevice(): string;
  end;

var
  mainForm: TmainForm;

implementation

{$R *.dfm}

// N
procedure TmainForm.FormCreate(Sender: TObject);
begin
  LoadDeviceList();


	if DDSD1.Initialized then
		GetSPKConfig()
  else begin
  	MessageDlg('DirectX 8.0ȏ̃CXg[Kvł', mtWarning, [mbOK], 0 );
    Application.Terminate;
  end;


end;

function TmainForm.SPK_Config(n: DWORD): Byte;
begin
	result := Byte( n );
end;

procedure TmainForm.lbSpkDblClick(Sender: TObject);
begin
	SetSPKConfig();
end;

procedure TmainForm.mnAboutClick(Sender: TObject);
begin
	MessageDlg('Xs[JZN^[ ver1.2'+#13#10#13#10+'Copyright (C) 2003-2005 Hosikiti. All rights reserved.',
  	mtInformation, [mbOK], 0 );
end;

procedure TmainForm.mnExitClick(Sender: TObject);
begin
	Close;
end;

procedure TmainForm.SetSPKConfig;
var
	val : DWORD;
begin
	val := 0;
	case LBSpk.ItemIndex of
  	0 : val := DSSPEAKER_DIRECTOUT;
    1 : val := DSSPEAKER_HEADPHONE;
    2 : val := DSSPEAKER_STEREO;
    3 : val := DSSPEAKER_QUAD;
    4 : val := DSSPEAKER_5POINT1;
    5 : val := DSSPEAKER_7POINT1;
    6 : val := DSSPEAKER_SURROUND;
  end;

  DDSD1.DSound.SetSpeakerConfig( val );
  edNow.Text := lbSPK.Items[ lbSPK.ItemIndex ];
end;

procedure TmainForm.mnReloadClick(Sender: TObject);
begin
  LoadDeviceList();
	GetSPKConfig();
end;

procedure TmainForm.GetSPKConfig;
var
	res : DWORD;
  cfg : Byte;
begin
	DDSD1.DSound.GetSpeakerConfig(@res);

  cfg := SPK_Config(res);
  case cfg of
  	DSSPEAKER_DIRECTOUT : lbSPK.ItemIndex := 0;
    DSSPEAKER_HEADPHONE : lbSPK.ItemIndex := 1;
	  DSSPEAKER_STEREO    : lbSPK.ItemIndex := 2;
    DSSPEAKER_QUAD      : lbSPK.ItemIndex := 3;
    DSSPEAKER_5POINT1   : lbSPK.ItemIndex := 4;
    DSSPEAKER_7POINT1   : lbSPK.ItemIndex := 5;
    DSSPEAKER_SURROUND  : lbSPK.ItemIndex := 6;
  end;

  edNow.Text := lbSPK.Items[ lbSPK.ItemIndex ];
end;

function TmainForm.GetPlayDevice: string;
var
  Reg : TRegistry;
begin
  Reg := TRegistry.Create;
  try
    Reg.RootKey := HKEY_CURRENT_USER;
    Reg.OpenKey( 'Software\Microsoft\Multimedia\Sound Mapper', FALSE );
    Result := Reg.ReadString( 'Playback' );
  finally
    Reg.Free;
  end;
end;

procedure TmainForm.SetPlayDevice(devName: string);
var
  Reg : TRegistry;
begin
  Reg := TRegistry.Create;
  try
    Reg.RootKey := HKEY_CURRENT_USER;
    Reg.OpenKey( 'Software\Microsoft\Multimedia\Sound Mapper', FALSE );
    Reg.WriteString( 'Playback', devName );
  finally
    Reg.Free;
  end;
end;

procedure TmainForm.LoadDeviceList;
var
  n, i : integer;
  devInfo : TWaveOutCaps;
  activeDev: string;
begin
  n := waveOutGetNumDevs();
  cmbDevice.Clear;

  if n = 0 then begin
    cmbDevice.Items.Add('o̓foCX܂');
    cmbDevice.ItemIndex := 0;
    exit;
  end;

  for i:=0 to n-1 do begin
    waveOutGetDevCaps(i, @devInfo, SizeOf(TWaveInCaps) );
    cmbDevice.Items.Add( devInfo.szPname );
  end;

  activeDev := GetPlayDevice();
  i := cmbDevice.Items.IndexOf( activeDev );
  if i <> -1 then
    cmbDevice.ItemIndex := i
  else begin
    cmbDevice.ItemIndex := 0;
    SetPlayDevice( cmbDevice.Items[0] );
  end;

end;

procedure TmainForm.cmbDeviceSelect(Sender: TObject);
begin
  SetPlayDevice( cmbDevice.Text );
end;

end.
